package com.ywt.mg.web.controllers.hospital;

import com.ywt.mg.core.MGRight;
import com.ywt.mg.core.utils.Checker;
import com.ywt.mg.core.utils.serializers.JsonSerializer;
import com.ywt.mg.domain.models.ConstantDef;
import com.ywt.mg.params.deposit.QueryDepositListRequest;
import com.ywt.mg.services.AuthService;
import com.ywt.mg.services.DepositService;
import com.ywt.mg.services.DownloadRecordService;
import com.ywt.mg.services.IdGenerator;
import com.ywt.mg.web.BaseResponse;
import com.ywt.mg.web.controllers.DepositController;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@RestController("/hosp/deposit")
@RequestMapping({"/hosp/deposit"})
@MGRight
public class HospDepositController {

    private static Logger logger = LoggerFactory.getLogger(HospDepositController.class);


    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private DownloadRecordService downloadRecordService;

    @Autowired
    private AuthService authService;

    @Autowired
    private DepositService depositService;




    @RequestMapping({"/downloadDepositList"})
    public BaseResponse downloadDepositList(@RequestBody QueryDepositListRequest request) {
        int currentAdminId = Checker.getIntegerValue(authService.getCurrentAdminId());
//        request.setCurrentAdminId(currentAdminId);
        // 插入记录
        int  hospital = authService.getCurrentHospitalId();
            request.setHospitalId(hospital);
//        if(request.getHosp() > 0){
//            hospital = authService.getCurrentHospitalId();
//            request.setHospitalId(hospital);
//        }
        request.setHosp(1);
        int downloadRecordId = idGenerator.genDownloadRecordId();
        String name = "住院押金";
        String fileName = "住院押金";
        String excelSuffixFormat = ConstantDef.EXCEL_SUFFIX_FORMAT;
        String paramUrl = "/hosp/deposit/downloadDepositList";
        String paramJson = JsonSerializer.toJson(request);
        downloadRecordService.getOrInsertDownloadRecordByHosp(downloadRecordId, name, fileName + excelSuffixFormat, paramUrl, paramJson);
        Thread t = new Thread() {
            @Override
            public void run() {
                depositService.downloadDepositList(downloadRecordId, fileName, request);
            }
        };
        t.start();
        return new BaseResponse().succeed("后台下载中...");
    }

    @RequestMapping({"/downloadDepositBillList"})
    public BaseResponse downloadDepositBillList(@RequestBody QueryDepositListRequest request) {
        int currentAdminId = Checker.getIntegerValue(authService.getCurrentAdminId());
//
        int  hospital = authService.getCurrentHospitalId();
        request.setHospitalId(hospital);
//        if(request.getHosp() > 0){
//            hospital = authService.getCurrentHospitalId();
//            request.setHospitalId(hospital);
//        }
        request.setHosp(1);
        int downloadRecordId = idGenerator.genDownloadRecordId();
        String name = "住院押金对账数据";
        String fileName = "住院押金对账数据" +
                "";
        String excelSuffixFormat = ConstantDef.EXCEL_SUFFIX_FORMAT;
        String paramUrl = "/hosp/deposit/downloadDepositBillList";
        String paramJson = JsonSerializer.toJson(request);
        downloadRecordService.getOrInsertDownloadRecordByHosp(downloadRecordId, name, fileName + excelSuffixFormat, paramUrl, paramJson);
        Thread t = new Thread() {
            @Override
            public void run() {
                depositService.downloadDepositBillList(downloadRecordId, fileName, request);
            }
        };
        t.start();
        return new BaseResponse().succeed("后台下载中...");
    }
}
